//Bridge桥接类,包括同步调用方法callRetStr，异步调用方法callByNotify,异步回调方法bridgeNotify
var Bridge=
{
	  //函数标识 自增
    callbackid:0,
    //存储异步回调结构，包括：封装类回调函数1callback1，用户回调函数1usercallback1，封装类回调函数2callback2，用户回调函数2usercallback2，封装对象类object，调用函数名functionName，调用函数参数param1-param7
    callbacks:{},
    //同步函数调用Js->Native，参数为：调用函数名functionName，调用函数参数param1-param7
    callRetStr:function(functionName,param1,param2,param3,param4,param5,param6,param7)
    {
    	  Log.i("webviewtest","callRetStr1");
        var id = Bridge.callbackid++;
        Log.i("webviewtest","callRetStr2");
        return  NativeBridge.callRetStr(functionName,id,param1,param2,param3,param4,param5,param6,param7);
    },
    //同步函数调用Js->Native,参数为：封装类回调函数1callback1，用户回调函数1usercallback1，封装类回调函数2callback2，用户回调函数2usercallback2，封装对象类object，调用函数名functionName，调用函数参数param1-param7
    callByNotify:function(callback1,usercallback1,callback2,usercallback2,object,functionName,param1,param2,param3,param4,param5,param6,param7)
    {
    	  Log.i("webviewtest","callByNotify1");
        var id = Bridge.callbackid++;
        //若需要回调函数才需存储
        if(callback1 != null || callback2 != null){
        	Bridge.callbacks[id] = {callback1:callback1, usercallback1:usercallback1, callback2:callback2,usercallback2:usercallback2,object:object};
        	Log.i("webviewtest","callByNotify2");
        }
        Log.i("webviewtest","callByNotify3");
        return  NativeBridge.callRetStr(functionName,id,param1,param2,param3,param4,param5,param6,param7);
    },
    //异步回调函数Native->Js,参数为：函数标识id，调用函数名functionName，调用函数参数param1-param7
    bridgeNotify:function(id,callbackNumber,param1,param2,param3,param4,param5,param6,param7)
    {
        Log.i("webviewtest","bridgeNotify1");
        var callback = Bridge.callbacks[id];
        Log.i("webviewtest","bridgeNotify2");
				if (callback)
				{
					if (callbackNumber == 1 )
					{
						 Log.i("webviewtest","bridgeNotify3 callbackNumber == 1");
		         callback.callback1(id,param1,param2,param3,param4,param5,param6,param7);
		         Log.i("webviewtest","bridgeNotify4 callbackNumber == 1");
			    }
			    else if (callbackNumber == 2)
			    {
			    	Log.i("webviewtest","bridgeNotify3 callbackNumber == 2");
						callback.callback2(id,param1,param2,param3,param4,param5,param6,param7);
						Log.i("webviewtest","bridgeNotify4 callbackNumber == 2");
		      }		            
		      delete Bridge.callbacks[id];	            
				}
    }
    
}

//JSON解析	
var JSON={
  parse:function(str){
	  return eval("(" + str + ")");
  }
};
