﻿
var webkitObjects = {};

//数据库
function s_DB_open(browser,callid,id,dbName,path)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在	
		var db = obj.object;
		res = db.open(dbName,path);
		
	}
	else
	{
		//不存在	
		var db = new DB();
		res = db.open(dbName,path);
		webkitObjects[id] = {object:db};
	}
	browser.bridgeReturnStr(callid, res);
}
function s_DB_isopen(browser,callid,id,dbName,path)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.isOpen();		
	}	
	browser.bridgeReturnStr(callid, res);
}
function s_DB_close(browser,callid,id,dbName,path)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.close();		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_createTable(browser,callid,id,tablename,arraytext)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在
		var array = jsonStringToArray(arraytext);		
		var db = obj.object;
		res = db.createTable(tablename,array);
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_dropTable(browser,callid,id,tablename)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.dropTable(tablename);
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_isTableExist(browser,callid,id,tablename)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.isTableExist(tablename);
	}	
	browser.bridgeReturnStr(callid, res);
}
function s_DB_getTableCols(browser,callid,id,tablename)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "[]";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array = db.getTableCols(tablename);
		res = arrayToJsonString(array);
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_addCol(browser,callid,id,tableName, colName, colType, colDefaultvalue)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.addCol(tableName, colName, colType, colDefaultvalue);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_query(browser,callid,id,sql)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "[]";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array = db.query(sql);
		res = JsonObjectToString(array);	
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_execute(browser,callid,id,sql)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		res = db.execute(sql);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_executes(browser,callid,id,sqls)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array = jsonStringToArray(sqls);
		res = db.executes(array);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_transaction(browser,callid,id,sqls)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array = jsonStringToArray(sqls);
		res = db.transaction(array);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_insert(browser,callid,id,tabName,colNames,colValues)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array1 = jsonStringToArray(colNames);
		var array2 = jsonStringToArray(colValues);
		res = db.insert(tabName,array1,array2);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_update(browser,callid,id,tabName, colNames, colValues, optionColNames,optionColValues)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;
		var array1 = jsonStringToArray(colNames);
		var array2 = jsonStringToArray(colValues);
		var array3 = jsonStringToArray(optionColNames);
		var array4 = jsonStringToArray(optionColValues);
		res = db.update(tabName,array1,array2,array3,array4);		
	}	
	browser.bridgeReturnStr(callid, res);
}

function s_DB_deleteData(browser,callid,id,tabName,optionColNames,optionColValues)
{
	//先查找是否存在
	var obj = webkitObjects[id];
	var res = "false";
	if(obj)
	{
		//存在		
		var db = obj.object;	
		var array1 = jsonStringToArray(optionColNames);
		var array2 = jsonStringToArray(optionColValues);
		res = db.deleteData(tabName,array1,array2);		
	}	
	browser.bridgeReturnStr(callid, res);
}











//编/解码类工具类方法
function s_EncryptionUtil_aesbase64Encode(browser,callid,input,key)
{
	var retValue = Util.aesbase64Encode(input,key);	
	browser.bridgeReturnStr(callid, retValue);
}
function s_EncryptionUtil_base64aesDecode(browser,callid,input,key)
{
	var retValue = Util.base64aesDecode(input,key);	
	browser.bridgeReturnStr(callid, retValue);
}
function s_EncryptionUtil_aesFileDecode(browser,callid,srcPath,dstPath,key)
{
	Util.aesFileDecode(srcPath,dstPath,key);	
	browser.bridgeReturnStr(callid, "");
}
function s_EncryptionUtil_aesFileEncode(browser,callid,srcPath,dstPath,key)
{
	Util.aesFileEncode(srcPath,dstPath,key);	
	browser.bridgeReturnStr(callid, "");
}
function s_EncryptionUtil_base64Decode (browser,callid,src)
{
	var retValue = Util.base64Decode(src);	
	browser.bridgeReturnStr(callid, retValue);
}
function s_EncryptionUtil_base64Encode (browser,callid,src)
{
	var retValue = Util.base64Encode(src);	
	browser.bridgeReturnStr(callid, retValue);
}
function s_EncryptionUtil_createQrImage(browser,callid,content,savePath,size)
{
	var successFun = function(path)
	{
		browser.bridgeNotify(makeNotifyData(callid,1,path));
	}
	var failFun = function(path)
	{
		browser.bridgeNotify(makeNotifyData(callid,2,path));
	}
	Util.createQrImage(content,savePath,size,successFun,failFun);	
	browser.bridgeReturnStr(callid, "");
}
function s_EncryptionUtil_md5 (browser,callid,src)
{
	var retValue = Util.md5(src);	
	browser.bridgeReturnStr(callid, retValue);
}
function s_EncryptionUtil_urlEncode (browser,callid,src,encodeType)
{
	var retValue = Util.urlEncode(src,encodeType);	
	browser.bridgeReturnStr(callid, retValue);
}
//终端设备操作工具类
function s_DeviceUtil_startLight(browser,callid)
{
	Util.startLight();	
	browser.bridgeReturnStr(callid, "");
}
function s_DeviceUtil_closeLight(browser,callid)
{
	Util.closeLight();	
	browser.bridgeReturnStr(callid, "");
}
function s_DeviceUtil_getDeviceType(browser, callid)
{
	var retValue = Util.getDeviceType();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getEsn(browser, callid)
{
	var retValue = Util.getEsn();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getImsi(browser, callid)
{
	var retValue = Util.getImsi();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getMac(browser, callid)
{
	var retValue = Util.getMac();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getOs(browser, callid)
{
	var retValue = Util.getOs();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getOsVersion(browser, callid)
{
	var retValue = Util.getOsVersion();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getPhoneModel(browser, callid)
{
	var retValue = Util.getPhoneModel();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getScreenHeight(browser, callid)
{
	var retValue = Util.getScreenHeight();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getScreenWidth(browser, callid)
{
	var retValue = Util.getScreenWidth();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getNotifyBarHeight(browser, callid)
{
	var retValue = Util.getNotifyBarHeight();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_getLanguage(browser, callid)
{
	var retValue = Util.getLanguage();
	browser.bridgeReturnStr(callid, retValue);
}
function s_DeviceUtil_setVolume(browser,callid,dwVolume)
{
	Util.setVolume(dwVolume);	
	browser.bridgeReturnStr(callid, "");
}
function s_DeviceUtil_vibrate(browser,callid)
{
	Util.vibrate();	
	browser.bridgeReturnStr(callid, "");
}

function s_DeviceUtil_getDeviceType(browser,callid)
{
	 var res = util.getDeviceType();
	 browser.bridgeReturnStr(callid, res);
}
function s_DeviceUtil_getAvailableMemory(browser,callid)
{
	 var res = util.getAvailableMemory();
	 var text = "" + res;
	 browser.bridgeReturnStr(callid, text);
}

//短信工具类
function s_SmsUtil_openSystemSms(browser,callid,phone,content)
{
	Util.openSystemSms(phone,content);	
	browser.bridgeReturnStr(callid, "");
}
function s_SmsUtil_sendSms(browser,callid,phone,content)
{
	Util.sendSms(phone,content);	
	browser.bridgeReturnStr(callid, "");
}
//电话工具类
function s_PhoneUtil_openSystemDial(browser,callid,phone)
{
	Util.openSystemDial(phone);	
	browser.bridgeReturnStr(callid, "");
}
function s_PhoneUtil_tel(browser,callid,phone)
{
	Util.tel(phone);	
	browser.bridgeReturnStr(callid, "");
}
function s_PhoneUtil_getCallRecords(browser,callid,callType)
{
	var obj = null;
	if(callType == null)
	{
		 obj = Util.getCallRecords();
	}
	else
	{
		 obj = Util.getCallRecords(callType);
	}	 
	var retValue = JSON.stringify(obj, ["name", "startTime", "phoneNumber","endTime","callType","objName"]);	
	browser.bridgeReturnStr(callid, retValue);
}
//文件操作工具类
function s_FileUtil_deleteFolder(browser,callid,dir)
{
	var retValue = Util.deleteFolder(dir);
	browser.bridgeReturnStr(callid, retValue);
}
function s_FileUtil_readFile(browser,callid,filePath)
{
	var retValue = Util.readFile(filePath);
	browser.bridgeReturnStr(callid, retValue);
}
function s_FileUtil_writeFile(browser,callid,filePath,content,mode)
{
	var retValue = Util.writeFile(filePath,content,mode);
	browser.bridgeReturnStr(callid, retValue);
}
function s_FileUtil_unZip(browser,callid,zipFilePath,folderFilePath,pwd)
{
	var unzipCallBack = function(result,path)
	{
    	browser.bridgeNotify(makeNotifyData(callid,1,result,path));
 	}
	Util.unZip(zipFilePath,folderFilePath,unzipCallBack,pwd);	
	browser.bridgeReturnStr(callid, "");
}
//压缩文件
function s_FileUtil_zip(browser, callid,folderFilePath,zipFilePath,pwd)
{
    var zipCallBack = function(result,path)
    {
    	browser.bridgeNotify(makeNotifyData(callid,1,result,path));
    }
    //开始压缩
    Util.zip(folderFilePath,zipFilePath,zipCallBack,pwd);
    browser.bridgeReturnStr(callid, "");
}
//定位操作工具类
function s_GpsUtil_getCellIdInfo(browser, callid)
{
	var obj = Util.getCellIdInfo();
	var retValue = JSON.stringify(obj, ["cellId", "countryCode", "networkCode","locationAreaCode","radioType","objName"]);
	browser.bridgeReturnStr(callid, retValue);
}
function s_GpsUtil_getGpsState(browser,callid)
{
	var retValue = Util.getGpsState();
	browser.bridgeReturnStr(callid, retValue);
}
function s_GpsUtil_getNetGpsState(browser,callid)
{
	var retValue = Util.getNetGpsState();
	browser.bridgeReturnStr(callid, retValue);
}
function s_GpsUtil_startGpsSetting(browser,callid)
{
	Util.startGpsSetting();
	browser.bridgeReturnStr(callid, "");
}
//基座相关工具类
function s_ClientUtil_exit(browser,callid,content)
{
	Util.exit(content);
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_exitNoAsk(browser,callid)
{
	Util.exitNoAsk();
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_getBadgeNumber(browser,callid)
{
	var retValue = Util.getBadgeNumber();
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_setBadgeNumber(browser,callid,number)
{
	Util.setBadgeNumber(number);
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_getClientId(browser,callid)
{
	var retValue = Util.getClientId();
	browser.bridgeReturnStr(callid, retValue);
}
//获取注册信息
function s_ClientUtil_getRegister(browser, callid)
{
	var obj = Util.getRegister();
	var retValue = JSON.stringify(obj, ["username", "ec", "phone","objName"]);
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_setRegister(browser,callid,registerInfo,isHasSuccessFun, isHasFailFun)
{	
	var jsonRegisterObj = JSON.parse(registerInfo);
	var exmobiRegisterObj = new RegisterInfo();
	exmobiRegisterObj.ec = jsonRegisterObj.ec;
	exmobiRegisterObj.username = jsonRegisterObj.username;
	exmobiRegisterObj.phone = jsonRegisterObj.phone;	
	var successFun = function(Response)
	{
		  var retValue = JSON.stringify(Response, ["objName", "responseText", "status"]);		 
    	browser.bridgeNotify(makeNotifyData(callid,1,retValue));
  }
	var errorFun = function(Response)
	{
		  var retValue = JSON.stringify(Response, ["objName", "responseText", "status"]);		 
    	browser.bridgeNotify(makeNotifyData(callid,2,retValue));
  }
  if(isHasSuccessFun == "true" && isHasFailFun == "true")
  {
  	Util.setRegister(exmobiRegisterObj,successFun,errorFun);
  }
  else if(isHasSuccessFun == "false" && isHasFailFun == "true" )
  {
  	 Util.setRegister(exmobiRegisterObj,null,errorFun);
  }
  else if(isHasSuccessFun == "true" && isHasFailFun == "false" )
  {
  	 Util.setRegister(exmobiRegisterObj,successFun,null);
  } 
  else
  {
  	 Util.setRegister(exmobiRegisterObj);
  }	

	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_getSetting(browser, callid)
{
	var obj = Util.getSetting();
	var retValue = JSON.stringify(obj, ["objName","ip", "port", "sslport","isssl","cachetime","ispushopen"]);
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_saveSetting(browser,callid,settinginfo)
{
	var jsonSettingObj = JSON.parse(settinginfo);
	var exmobiSettingObj = new SettingInfo();
	exmobiSettingObj.ip = jsonSettingObj.ip;
	exmobiSettingObj.port = jsonSettingObj.port;
	exmobiSettingObj.sslport = jsonSettingObj.sslport;	
	exmobiSettingObj.isssl = jsonSettingObj.isssl;
	exmobiSettingObj.cachetime = jsonSettingObj.cachetime;
	exmobiSettingObj.ispushopen = jsonSettingObj.ispushopen;
	Util.saveSetting(exmobiSettingObj);
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_getVersion(browser,callid)
{
	var retValue = Util.getVersion();
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_shareClientToFriends(browser,callid)
{
	Util.shareClientToFriends();
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_startClientUpdate(browser,callid)
{
	Util.startClientUpdate();
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_startAppUpdate(browser,callid)
{
	Util.startAppUpdate();
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_cleanCache(browser,callid)
{
	var res = Util.cleanCache();
	browser.bridgeReturnStr(callid, res);
}
function s_ClientUtil_execScript(browser,callid,script)
{	
	Util.execScript(script);
	browser.bridgeReturnStr(callid, "");
}
function s_ClientUtil_openAdminSelectedAppUI(browser,callid)
{
	Util.openAdminSelectedAppUI();
	browser.bridgeReturnStr(callid, "");
}

function s_ClientUtil_random(browser,callid,start,end)
{
	var retValue = Util.random(stringToInt(start),stringToInt(end));
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_clearDownload(browser,callid)
{
	var retValue = Util.clearDownload();
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_download(browser,callid,url,dstpath,isblock)
{
	var successFun = function(path)
	{
    	browser.bridgeNotify(makeNotifyData(callid,1,path));
  }
	var errorFun = function(path)
	{
    	browser.bridgeNotify(makeNotifyData(callid,2,path));
  }
  if(isblock == null)
  {
  	 Util.download(url,dstpath,successFun,errorFun);	
  }
  else
  {
  	 if(dstpath == null)
  	   detpath = "";
  	 Util.download(url,dstpath,successFun,errorFun,isblock);
  }	
	browser.bridgeReturnStr(callid, "");
}

function s_ClientUtil_openApp(browser, callid,appid,parameterInfos)
{
	 var array = new Array();	 
	 var json = JSON.parse(parameterInfos);
	 var len = json.length;	
	 for(var i = 0; i < len;i++)
	 {
	 	 var v = new ParameterInfo();
	 	 v.key = json[i].key;
	 	 v.value = json[i].value;	 	
	 	 array.push(v);
	 }		  
	 Util.openApp(appid,array);
}

//获取下载列表
function s_ClientUtil_getDownloadInfos(browser, callid, type)
{
	var obj = Util.getDownloadInfos(parseInt(type));
	var retValue = JSON.stringify(obj, ["type", "fileName", "filePath","url","totalSize","downloadedSize","updateTime","objName"]);
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_getAppId(browser,callid)
{
	var retValue = Util.getAppId();
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_getApplicationInfos(browser, callid, type)
{
	var obj = Util.getApplicationInfos();
	var retValue = JSON.stringify(obj, ["objName", "status", "type","appid","appname","description","localVersion","serverVersion", "date", "homepageSrc","vendorUrl","vendorEmail","iconMain","iconLogo","iconSelectedLogo","size"]);
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_getAppPath(browser,callid)
{
	var retValue = Util.getAppPath();
	browser.bridgeReturnStr(callid, retValue);
}
function s_ClientUtil_getDB(browser,callid,appid,id)
{
	var res = "false";
	var db = Util.getDB(appid);
	if(db)
	{
		 res = "true";
		 webkitObjects[id] = {object:db};			 
	}
	browser.bridgeReturnStr(callid, res);
}
//多媒体操作工具类
function s_MediaUtil_beep(browser,callid,path)
{
	if(path==null)
	{
	Util.beep();
	}else{
	Util.beep(path);
	}
	
	browser.bridgeReturnStr(callid, "");
}
function s_MediaUtil_openVideo(browser,callid,path)
{
	Util.openVideo(path);
	browser.bridgeReturnStr(callid, "");
}

/*音频播放工具类 - begin*/
//开始播放
function s_AudioPlayer_start(browser, callid, url, isLooping)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.start(url, isLooping);
	browser.bridgeReturnStr(callid, retValue);
}
//定位到音频某一点并播放
function s_AudioPlayer_seekTo(browser, callid, position)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.seekTo(position);
	browser.bridgeReturnStr(callid, retValue);
}
//暂停音频播放
function s_AudioPlayer_pause(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.pause();
	browser.bridgeReturnStr(callid, retValue);
}
//从暂停状态恢复播放
function s_AudioPlayer_resume(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.resume();
	browser.bridgeReturnStr(callid, retValue);
}
//停止播放
function s_AudioPlayer_stop(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.stop();
	browser.bridgeReturnStr(callid, retValue);
}
//得到目前音频的总长度
function s_AudioPlayer_getDuration(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.getDuration();
	browser.bridgeReturnStr(callid, retValue);
}
//获取当前音频的播放状态
function s_AudioPlayer_getStatus(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.getStatus();
	browser.bridgeReturnStr(callid, retValue);
}
//得到目前音频到播放位置
function s_AudioPlayer_getCurrentPosition(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.getCurrentPosition();
	browser.bridgeReturnStr(callid, retValue);
}
//当前播放的音频是否设置为循环播放
function s_AudioPlayer_isLooping(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.isLooping();
	browser.bridgeReturnStr(callid, retValue);
}
//设置播放音频的音量
function s_AudioPlayer_setVolume(browser, callid, volume)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.setVolume(volume);
	browser.bridgeReturnStr(callid, retValue);
}
//得到当前播放的音频的音量
function s_AudioPlayer_getVolume(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.getVolume();
	browser.bridgeReturnStr(callid, retValue);
}
//调高音量
function s_AudioPlayer_volumeUp(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.volumeUp();
	browser.bridgeReturnStr(callid, retValue);
}
//降低音量
function s_AudioPlayer_volumeDown(browser, callid)
{
    var audio = Util.getAudioPlayer();
	var retValue = audio.volumeDown();
	browser.bridgeReturnStr(callid, retValue);
}
/*音频播放工具类 - end*/


/*录音工具类 - begin*/
//开始录音
function s_Record_startRecord(browser, callid)
{
    var record = Util.getRecord();
	var retValue = record.startRecord();
	browser.bridgeReturnStr(callid, retValue);
}
//是否正在录音
function s_Record_isRecord(browser, callid)
{
    var record = Util.getRecord();
	var retValue = record.isRecord();
	browser.bridgeReturnStr(callid, retValue);
}
//结束录音
function s_Record_stopRecord(browser, callid)
{
    var record = Util.getRecord();
	var retValue = record.stopRecord();
	browser.bridgeReturnStr(callid, retValue);
}
//返回或设置生成文件的路径
function s_Record_path(browser, callid, p)
{
    var record = Util.getRecord();
    record.path = p;
    browser.bridgeReturnStr(callid, "");
}
//返回或设置最大录音时间
function s_Record_maxtime(browser, callid, time)
{
    var record = Util.getRecord();
    record.maxtime = time;
    browser.bridgeReturnStr(callid, "");
}
//返回实际的录音时间
function s_Record_recordtime(browser, callid)
{
    var record = Util.getRecord();
    var retValue = record.recordtime;

    browser.bridgeReturnStr(callid, retValue);
}
//返回实际的录音完成后的文件完整路径
function s_Record_value(browser, callid)
{
    var record = Util.getRecord();
    var retValue = record.value;

    browser.bridgeReturnStr(callid, retValue);
}
/*录音工具类 - end*/
/*网络工具类*/
//获取当前网络apn标识
function s_NetworkUtil_getApn(browser, callid)
{
	var retValue = Util.getApn();
	browser.bridgeReturnStr(callid, retValue);
}

//获取设备当前网络地址
function s_NetworkUtil_getNetIp(browser, callid)
{
	var retValue = Util.getNetIp();
	browser.bridgeReturnStr(callid, retValue);
}

//获取当前网络状态
function s_NetworkUtil_getConnectionType(browser, callid)
{
	var retValue = Util.getConnectionType();
	browser.bridgeReturnStr(callid, retValue);
}

function s_NetworkUtil_getConnectState(browser,callid,netType)
{
	var retValue = Util.getConnectState(netType);
	browser.bridgeReturnStr(callid, retValue);
}

function s_NetworkUtil_openApnSetting(browser,callid)
{
	Util.openApnSetting();
	browser.bridgeReturnStr(callid, "");
}
function s_NetworkUtil_startApnSetting(browser,callid)
{
	var retValue = Util.startApnSetting();
	browser.bridgeReturnStr(callid, retValue);
}
function s_NetworkUtil_startConnectSetting(browser,callid)
{
	var retValue = Util.startConnectSetting();
	browser.bridgeReturnStr(callid, retValue);
}
function s_NetworkUtil_getMobileConnectType(browser,callid)
{
	var retValue = Util.getMobileConnectType();
	browser.bridgeReturnStr(callid, retValue);
}


//系统原生程序相关操作类
function s_NativeUtil_getNativeVersion(browser,callid,packagename)
{
	var retValue = Util.getNativeVersion(packagename);
	browser.bridgeReturnStr(callid, retValue);
}
function s_NativeUtil_startActivity(browser,callid,packagename,activity,parameter,type)
{
	var errorCallFun = function(errorcode)
	{
    	browser.bridgeNotify(makeNotifyData(callid,1,errorcode));
  }	 
	Util.startActivity(packagename,activity, parameter,type,errorCallFun);
	browser.bridgeReturnStr(callid, "");
}

function s_NativeUtil_openSharedApp(browser,callid,url,param,downloadurl,alertmsg)
{
	 if(url != null && param != null && downloadurl != null && alertmsg != null)
	 {
	 		Util.openSharedApp(url,param,downloadurl,alertmsg);
	 }
	 else if(url != null && param != null && downloadurl != null )
	 {
	 		Util.openSharedApp(url,param,downloadurl);
	 }
	 else if(url != null && param != null)
	 {
	 		Util.openSharedApp(url,param);
	 }
	 else if(url != null)
	 {
	 		Util.openSharedApp(url);
	 }
}
function s_NativeUtil_installApk(browser,callid,apkFilePath)
{
	var successCallBack = function(packagename){
    	browser.bridgeNotify(makeNotifyData(callid,1,packagename));
    }
	
	Util.installApk(apkFilePath,successCallBack);
	browser.bridgeReturnStr(callid, "");
}
function s_NativeUtil_isAppInstalled(browser,callid,packagename)
{
	var retValue = Util.isAppInstalled(packagename);
	browser.bridgeReturnStr(callid, retValue);
}
function s_NativeUtil_uninstallApk(browser,callid,apkFilePath)
{
	var successCallBack = function(packagename){
    	browser.bridgeNotify(makeNotifyData(callid,1,packagename));
    }
	
	Util.uninstallApk(apkFilePath,successCallBack);
	browser.bridgeReturnStr(callid, "");
}
function s_NativeUtil_selectCameraPhoto(browser,callid,pwidth)
{
	var callFunction = function(packagename){
    	browser.bridgeNotify(makeNotifyData(callid,1,packagename));
    }
	
	Util.selectCameraPhoto(callFunction,pwidth);
	browser.bridgeReturnStr(callid, "");
}
function s_NativeUtil_saveToAlbum(browser,callid,imgPath)
{
	var retValue = Util.saveToAlbum(imgPath);
	browser.bridgeReturnStr(callid, retValue);
}
function s_NativeUtil_openImageContent(browser,callid,imgBase64)
{
	var retValue = Util.openImageContent(imgBase64);
	browser.bridgeReturnStr(callid, retValue);
}
function s_NativeUtil_open(browser,callid,path)
{
	Util.open(path);
	browser.bridgeReturnStr(callid, "");
}
function s_NativeUtil_startWifiServer(browser,callid)
{
	Util.startWifiServer();
	browser.bridgeReturnStr(callid, "");
}
function s_NativeUtil_browser(browser,callid,url)
{
	Util.browser(url);
	browser.bridgeReturnStr(callid, "");
}




function s_File_isFolder(browser,callid,filepath,isforder)
{		 
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.isFolder();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_getParent(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.getParent();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_exists(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.exists();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_length(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.length();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_deleteFile(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.deleteFile();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_mkdir(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.mkdir();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_mkdirs(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.mkdirs();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_createFile(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.createFile();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_renameTo(browser,callid,filepath,isforder,destPath)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.renameTo(destPath);
	 browser.bridgeReturnStr(callid, res);
}
function s_File_copyTo(browser,callid,filepath,isforder,destPath)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.copyTo(destPath);
	 browser.bridgeReturnStr(callid, res);
}
function s_File_getFilePath(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.getFilePath();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_getFileName(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var res = file.getFileName();
	 browser.bridgeReturnStr(callid, res);
}
function s_File_getModifiedDate(browser,callid,filepath,isforder)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var v = file.getModifiedDate();
	 var res = v.toString();
	 res = res.replace(/-/g,"/");	
	 browser.bridgeReturnStr(callid, res);
}

function s_File_list(browser,callid,filepath,isforder,filter)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var list = file.list(filter);
	 var res = "[";	
	 for(var i = 0; i < list.length;i = i + 1)
	 {
	 	  res = res + '{ "name":"' + list[i] + '"}';
	 	  if( i != list.length - 1)
	 	  {
	 	  	 res = res + ",";
	 	  }	 	  
	 }	 
	 res =  res + "]";		
	 browser.bridgeReturnStr(callid, res);
}

function s_File_listFiles(browser,callid,filepath,isforder,filter)
{
	 var file = new File(filepath,stringToBool(isforder));
	 var list = file.listFiles(filter);
	 var res = "[";	
	 for(var i = 0; i < list.length;i = i + 1)
	 {
	 	  res = res + "{";
	 	  res = res + '"name":"' + list[i].getFilePath() + '",';
	 	  res = res + '"isforder":"' + list[i].isFolder() + '"';
	 	  res = res + "}";
	 	  if( i != list.length - 1)
	 	  {
	 	  	 res = res + ",";
	 	  }	 	  
	 }	 
	 res =  res + "]";	
	 browser.bridgeReturnStr(callid, res);
}


//JSON转字符串
var JSON=
{
  stringify:function(o, keys){
    if (o == null) {
    	return "{}";
    }
    var output =[];
    if(o instanceof Array)
    {
	     for(var i =0;i<o.length;i++)
	     {
	        output.push(JSON.stringify(o[i],keys));
	     }
	    return  output="["+output.join()+"]"; 
    }else{
       for (var i=0; i<keys.length; i++) {
       var val = o[keys[i]];
       if (val == null){
          continue;
       }
       if (typeof(val) == 'string'){
          output.push('"' + keys[i] + '":'  + '"' + val + '"' );
        }else if (typeof(val) == 'number') {
          output.push('"' + keys[i] + '":'  +  val   );
        }else{  
          output.push('"' + keys[i] + '":'  +  val   );
        }
      }
	    return "{" + output.join(",  ") +"}";
    }
  },
  parse:function(str){
	  return eval("(" + str + ")");
  }
}

function stringToBool(text)
{
	 if(text.toLowerCase() == "true" )
	 {
	 	 return true;
	 }
	 else
	 {
	 	 return false;
	 }
}

function stringToInt(text)
{
	 return parseInt(text);
}

  //该方法用于回传webview异步回调构建字符串
function makeNotifyData(callId,callBackNumber,param1,param2,param3,param4,param5,param6,param7){
    var ret = "";
    ret = ret + callId + "," + callBackNumber;
    if(param1!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param1) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }
    if(param2!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param2) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }

    if(param3 != null )
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param3) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }

    if(param4!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param4) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }

    if(param5!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param5) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }

    if(param6!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param6) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }

    if(param7!=null)
    {
    	ret = ret + ",\"" + replaceNotifyData(""+param7) + "\"";
    }
    else
    {
	ret = ret + ",null";
    }
    return ret;
  }

//替换字符串中" 为\"
function replaceNotifyData(param)
{
	return param.replace(/"/g,'\\"');
}




//解码
function s_Decode_startDecord(browser, callid){
    var decode = new Decode();
    
    decode.onCallback = function(){
       browser.bridgeNotify(makeNotifyData(callid,1,decode.isSuccess().toString(), decode.result, decode.time));
    }
    decode.startDecode();/*开始解码*/
    browser.bridgeReturnStr(callid, "");
}



//Ajax请求发送
function s_Ajax_send(browser, callid,url, method, data, requestHeader, isShowProgress){
    var successCallBack = function(ajax)
    {   	
    	browser.bridgeNotify(makeNotifyData(callid,1,ajax.status,ajax.responseText));
    }
    var failCallBack = function(ajax)
    {
    	browser.bridgeNotify(makeNotifyData(callid,2,ajax.status,ajax.responseText));
    }
    Log.i("ExMobi", "s_Ajax_send callid:" + callid + " url:" + url + " method:"+method+" data:"+data+" requestHeader:"+requestHeader+" isShowProgress:"+isShowProgress );
    var isProgress = false;
    if(isShowProgress == "true")
    {
    		isProgress = true;
    }
    //构建Ajax对象
	  var ajax = null;
	  if(url != null && method != null && data != null && requestHeader != null && isShowProgress != null)
	  {
	  	ajax = new Ajax(url,method,data,successCallBack,failCallBack,requestHeader,isProgress);
	  }
	  else if(url != null && method != null && data != null && requestHeader != null)
	  {
	  	ajax = new Ajax(url,method,data,successCallBack,failCallBack,requestHeader);
	  }
	  else if(url != null && method != null && data != null )
	  {
	  	ajax = new Ajax(url,method,data,successCallBack,failCallBack);
	  }
	  else if(url != null && method != null )
	  {
	  	ajax = new Ajax(url,method);
	  	ajax.successFunction = successCallBack;
	  	ajax.failFunction = failCallBack;
	  }
	  else if(url != null && method == null && data == null )
	  {
	  	 var json =  eval("("+url+")");	  	
	  	 delete json.successFunction;
	  	 delete json.failFunction;		  	
	  	 ajax = new Ajax(json);  	
	  	 ajax.successFunction = successCallBack;
	  	 ajax.failFunction = failCallBack;	  	
	  }
	  
	  //设置需要传递数据
  	ajax.send();
  	//返回数据
  	browser.bridgeReturnStr(callid, "");
}


function s_Ajax_responseToFile(browser,callid,data,path)
{	 
	 var ajax = new Ajax("1","2","3");
	 ajax.responseText = data;
	 var v = ajax.responseToFile(path);
	 browser.bridgeReturnStr(callid,v);
}

function s_window_getid(browser, callid)
{
	 var res = window.id;	
	 browser.bridgeReturnStr(callid,res);
}
function s_window_getname(browser, callid)
{
	 var res = window.name;
	 browser.bridgeReturnStr(callid,res);
}
function s_window_open(browser, callid,url, isNewWindow,isPop,features,param)
{
	  Log.i("Exmobi s_window_open",url + " " + isNewWindow + " " + isPop + " " + features + " " + param);
		if(url != null && isNewWindow != null && isPop != null && features != null && param != null )
		{
 			 window.open(url, isNewWindow,isPop,features,param);
 		}
 	  else if(url != null && isNewWindow != null && isPop != null && features != null )
		{
 			 window.open(url, isNewWindow,isPop,features);
 		}
		else if(url != null && isNewWindow != null && isPop != null )
		{
 			 window.open(url, isNewWindow,isPop);
 		}
	  else if(url != null && isNewWindow != null)
		{
 			 window.open(url, isNewWindow);
 		}
 		else if(url != null)
		{
 			 window.open(url);
 		}
}
function s_window_openData(browser, callid,data, isNewWindow,isPop,features,param)
{
	  Log.i("Exmobi s_window_openData",data + " " + isNewWindow + " " + isPop + " " + features + " " + param);
		if(data != null && isNewWindow != null && isPop != null && features != null && param != null )
		{
 			 window.openData(data, isNewWindow,isPop,features,param);
 		}
 	  else if(data != null && isNewWindow != null && isPop != null && features != null )
		{
 			 window.openData(data, isNewWindow,isPop,features);
 		}
		else if(data != null && isNewWindow != null && isPop != null )
		{
 			 window.openData(data, isNewWindow,isPop);
 		}
	  else if(data != null && isNewWindow != null)
		{
 			 window.openData(data, isNewWindow);
 		}
 		else if(data != null)
		{
 			 window.openData(data);
 		}
}

function s_window_close()
{
	window.close();
}

function s_window_getParameter(browser, callid,param)
{
	 var res =  window.getParameter(param);
	 browser.bridgeReturnStr(callid,res);
}
function s_window_setStringSession(browser, callid,key,value)
{
	 window.setStringSession(key,value);
}
function s_window_getStringSession(browser, callid,key)
{	
	 var res = window.getStringSession(key);
	 if(res == null)
	 {
	 	 res = "null";
	 }
	 browser.bridgeReturnStr(callid,res);
}
function s_window_setArraySession(browser, callid,key,value)
{
	 var json = JSON.parse(value);
	 var array = new Array();
	 for(var i = 0; i < json.length;i++)
	 {
	 	  var v = json[i].value;	 	 
	 	  array.push(v);	 	  
	 }	
	 window.setArraySession(key,array);
}

function s_window_getArraySession(browser, callid,key)
{	 
	 var text = "";
	 var array = window.getArraySession(key);	 
	 text = arrayToJsonString(array);
	 browser.bridgeReturnStr(callid,text);
}

function s_window_getPushParameters(browser, callid)
{
	 var v = window.getPushParameters();
	 if(v == null)
	 {
	 	 browser.bridgeReturnStr(callid,"null");
	 }
	 else
	 {
	 		var text = JsonObjectToString(v);
	 		browser.bridgeReturnStr(callid,text);
	 }	 
}
function s_window_getPushParameter(browser, callid,key)
{
	 var text = window.getPushParameter(key);	
	 browser.bridgeReturnStr(callid,text);
}
function s_window_getNativeParameter(browser, callid,key)
{
	 var res = window.getNativeParameter(key);	
	 if(res == null)
	 {
	 	 res = "null";
	 }
	 browser.bridgeReturnStr(callid,res);
}
function s_window_getNativeParameters(browser, callid)
{
	 var array = window.getNativeParameters();	
	 var res = JSON.stringify(array, ["key", "value","objName"]);	 
	 browser.bridgeReturnStr(callid,res);
}
function s_window_callExMobiFunction(browser, callid,script)
{
	 var v = eval(script);	 
	 browser.bridgeReturnStr(callid,v);
}




function JsonObjectToString(o)
{	
	var r = [];   
	if(typeof o =="string") return "\""+o.replace(/([\'\"\\])/g,"\\$1").replace(/(\n)/g,"\\n").replace(/(\r)/g,"\\r").replace(/(\t)/g,"\\t")+"\"";
  if(typeof o == "number") return "\"" + o + "\"";
 	if(typeof o == "boolean") return "\"" + o + "\"";
	if(typeof o =="undefined") return "";
	if(typeof o != "object") return o.toString();
	if(o===null) return null;
  if(o instanceof Array)
  {
     for(var i =0;i<o.length;i++)
     {
        r.push(this.JsonObjectToString(o[i]));
     }
     r="["+r.join()+"]"; 
  }
  else
  {              
     for(var i in o)
     {     	
        r.push('"'+i+'":'+this.JsonObjectToString(o[i]));
     }
     r="{"+r.join()+"}";
  }   
  return r; 
}


function arrayToJsonString(array)
{
		var text = "[";	 	
		var len = array.length;  
 	  for(var i = 0; i < len;i = i + 1)
 	  {
 	  	 text = text + '{\"value\":\"' + array[i] + '\"}';
 	  	 if(i != len - 1)
 	  	 {
 	  	 	  text = text + ",";
 	  	 }
 	  }	 	  
	 	text = text + "]";
	 	return text;
}

function jsonStringToArray(json)
{
	var json = JSON.parse(json);
	 var array = new Array();
	 for(var i = 0; i < json.length;i++)
	 {
	 	  var v = json[i].value;	 	 
	 	  array.push(v);	 	  
	 }
	 return array;
}

function s_window_logdebug(browser, callid,param1,param2)
{
    Log.i(param1,param2);
}
/*DIRECT HTTP工具类 - begin*/
//s_DirectAjax_send
function s_DirectAjax_send(browser, callid, jsonData)
{
     var successCallBack = function(ajax)
     {
         browser.bridgeNotify(makeNotifyData(callid,1,ajax.status,ajax.responseText));
     }
     var failCallBack = function(ajax)
     {
         browser.bridgeNotify(makeNotifyData(callid,2,ajax.status,ajax.responseText));
     }
     Log.i("ExMobi", "s_DirectAjax_send jsonData:" + jsonData);
     //设置需要传递数据
     var json = eval("("+jsonData+")");
     delete json.successFunction;
     delete json.failFunction;

     var ajax = new DirectAjax(json);
     ajax.successFunction = successCallBack;
     ajax.failFunction = failCallBack;
     ajax.send();
     //返回数据
     browser.bridgeReturnStr(callid, "");
}

//DirectDownload
function s_DirectDownload_send(browser, callid, jsonData)
{
    var successCallBack = function(ajax)
    {
        browser.bridgeNotify(makeNotifyData(callid,1,ajax.status,ajax.path));
    }
    var failCallBack = function(ajax)
    {
        browser.bridgeNotify(makeNotifyData(callid,2,ajax.status,ajax.path));
    }

    Log.i("ExMobi", "s_DirectDownload_send jsonData:" + jsonData);
    //设置需要传递数据
    var json = eval("("+jsonData+")");
    delete json.successFunction;
    delete json.failFunction;

    var ajax = new DirectDownload(json);
    ajax.successFunction = successCallBack;
    ajax.failFunction = failCallBack;
    ajax.send();
    //返回数据
    browser.bridgeReturnStr(callid, "");
}

//DirectFormSubmit
function s_DirectFormSubmit_send(browser, callid, jsonData){
    var successCallBack = function(ajax)
    {
    	Log.i("ExMobi", "s_DirectFormSubmit_sendsuccess jsonData:" +callid);
        browser.bridgeNotify(makeNotifyData(callid,1,ajax.status,ajax.responseText));
        Log.i("ExMobi", "s_DirectFormSubmit_sendsuccess jsonData:" +ajax.status);
    }
    var failCallBack = function(ajax)
    {
        browser.bridgeNotify(makeNotifyData(callid,2,ajax.status,ajax.responseText));
    }
    Log.i("ExMobi", "s_DirectFormSubmit_send jsonData:" + jsonData);
    //设置需要传递数据
    var json = eval("("+jsonData+")");
    delete json.successFunction;
    delete json.failFunction;

    var ajax = new DirectFormSubmit(json);
    ajax.successFunction = successCallBack;
    ajax.failFunction = failCallBack;
    ajax.send();
    //返回数据
    browser.bridgeReturnStr(callid, "");
}

//图片选择
function s_ImageChoice_start(browser,callid,nums,pwidth,path){
    var choice = new ImageChoice();
    choice.nums = nums;
    choice.pwidth = pwidth;
    choice.path = path;
    choice.onCallback = function(paths){
       browser.bridgeNotify(makeNotifyData(callid,1,arrayToJsonString(paths)));
    }
    choice.start();
    browser.bridgeReturnStr(callid, "");
}

//文件选择
function s_FileChoice_start(browser,callid,defaultPath,filter){
    var choice = new FileChoice();
   choice.defaultPath = defaultPath;
   choice.filter = filter;
    choice.onCallback = function(path){
       browser.bridgeNotify(makeNotifyData(callid,1,path));
    }
    choice.start();
    browser.bridgeReturnStr(callid, "");
}


/*DIRECT HTTP工具类 - end*/
